Riding in a Lift
time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

Imagine that you are in a building that has exactly n floors. You can move between the floors in a lift. Let's number the floors from bottom to top with integers from 1 to n. Now you're on the floor number a. You are very bored, so you want to take the lift. Floor number b has a secret lab, the entry is forbidden. However, you already are in the mood and decide to make k consecutive trips in the lift.

Let us suppose that at the moment you are on the floor number x (initially, you were on floor a). For another trip between floors you choose some floor with number y (y ≠ x) and the lift travels to this floor. As you cannot visit floor b with the secret lab, you decided that the distance from the current floor x to the chosen y must be strictly less than the distance from the current floor x to floor b with the secret lab. Formally, it means that the following inequation must fulfill: |x - y| < |x - b|. After the lift successfully transports you to floor y, you write down number y in your notepad.

Your task is to find the number of distinct number sequences that you could have written in the notebook as the result of k trips in the lift. As the sought number of trips can be rather large, find the remainder after dividing the number by 1000000007 (109 + 7).

Input

The first line of the input contains four space-separated integers nabk (2 ≤ n ≤ 5000, 1 ≤ k ≤ 5000, 1 ≤ a, b ≤ na ≠ b).

Output

Print a single integer — the remainder after dividing the sought number of sequences by 1000000007 (109 + 7).

Examples
input
5 2 4 1
output
2
input
5 2 4 2
output
2
input
5 3 4 1
output
0
Note

Two sequences p1, p2, ..., pk and q1, q2, ..., qk are distinct, if there is such integer j (1 ≤ j ≤ k), that pj ≠ qj.

Notes to the samples:

  1. In the first sample after the first trip you are either on floor 1, or on floor 3, because |1 - 2| < |2 - 4| and |3 - 2| < |2 - 4|.
  2. In the second sample there are two possible sequences: (1, 2); (1, 3). You cannot choose floor 3 for the first trip because in this case no floor can be the floor for the second trip.
  3. In the third sample there are no sought sequences, because you cannot choose the floor for the first trip.

【题意】有一n层楼的楼房,可坐电梯上下。初始位置在a层,b层楼门无法打开,所以无法到达。如果你当前在x层,你能走到y层当且仅当|x - y| < |x - b|.

每一次有效的移动可到达一个楼层,然后把楼层号写下,连续的移动就可写下一个序列。

问经过k次连续的移动后,产生的序列种数。

【分析】DP。dp[i][j]表示第j次移动到达i层楼的序列数,dp[i][j]=∑(dp[能够到达i层楼的楼层][j-1])%mod。所以这里需要求一个前缀和,然后去掉dp[i][j-1]。

#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define vi vector<int>
#define inf 0x3f3f3f3f
#define met(a,b) memset(a,b,sizeof a)
using namespace std;
typedef long long LL;
const int N = 5e3+;
const int mod = 1e9+;
int n,a,b,k;
LL dp[N][N],sum[N];
int main(){
scanf("%d%d%d%d",&n,&a,&b,&k);
dp[a][]=;
for(int i=;i<=n;i++){
sum[i]=(sum[i-]+dp[i][])%mod;
}
for(int j=;j<=k;j++){
for(int i=;i<=n;i++){
if(i>b){
int low=(i+b)/;
int up=n;
dp[i][j]=((sum[up]-sum[low]+mod)%mod-dp[i][j-]+mod)%mod;
}
else if(i<b){
int low=;
int up=(i+b)&==?(i+b)/:(i+b)/-;;
dp[i][j]=((sum[up]-sum[low]+mod)%mod-dp[i][j-]+mod)%mod;
}
//printf("i:%d j:%d dp:%lld\n",i,j,dp[i][j]);
}
sum[]=;
for(int i=;i<=n;i++){
sum[i]=(sum[i-]+dp[i][j])%mod;
}
}
LL ans=;
for(int i=;i<=n;i++)ans=(ans+dp[i][k])%mod;
printf("%lld\n",ans);
return ;
}

最新文章

  1. 如何通过命令行创建和设置一个MySQL用户
  2. spoj 694(后缀数组)
  3. request.getParameter()获取URL中文参数乱码的解决办法
  4. asp.net core 2.0+sqlsugar搭建个人网站系列(0)
  5. JMeter-自动生成测试报告
  6. 使用python脚本实现iOS图片资源压缩
  7. 想做AI测试,需要学习哪些数学知识?
  8. ceph mimic版本 部署安装
  9. Cyclic Components CodeForces - 977E(DFS)
  10. TZOJ 2560 Geometric Shapes(判断多边形是否相交)
  11. jquery.validate,错误信息位置
  12. 【LibreOJ】#6395. 「THUPC2018」城市地铁规划 / City 背包DP+Prufer序
  13. Laravel 本地化定义
  14. PS入门到精通完全自学教程
  15. Django中URL的解析和反查
  16. Maximum execution time of 30 seconds exceeded解决办法
  17. C语言中单引号和双引号
  18. Microsoft Edge Certified with EBS 12.1 and 12.2
  19. 再学UML-Bug管理系统UML2.0建模实例(四)
  20. HDU3308 LCIS

热门文章

  1. 【hdu1828/poj1177】线段树求矩形周长并
  2. 【NOIP】提高组2015 斗地主
  3. 【BZOJ】2190 [SDOI2008]仪仗队
  4. PACM Team(牛客第三场多校赛+dp+卡内存+打印路径)
  5. python初步学习-python控制流
  6. Ribbon自带负载均衡策略比较
  7. Java多线程学习(六)Lock锁的使用
  8. 第三周main参数传递-1 课堂测试
  9. dev_cpu_dead
  10. monkey测试===如何获取android app的Activity